import java.io.*;

public class StringZip2000
{

  private char signTable[];
  private String keyTable[];
  private int posInTable = 0;

  private TreeList treeList;

  public static void main(String args[])
  {
    StringZip2000 tempZip2000 = new StringZip2000();
  }

  public StringZip2000()
  {
    String inputStr = "";
    BufferedReader in = new BufferedReader(new InputStreamReader(System.in));

    System.out.print("Enter a string to be coded:");
    try
    {
      inputStr = in.readLine();
    }
    catch(IOException e)
    {
      System.out.println(e + "");
    }

    treeList = new TreeList();
    for(int i = 0; i < inputStr.length(); i++)
      treeList.addSign(inputStr.charAt(i));
    treeList.sortTree();

    signTable = new char[treeList.length() + 1];
    keyTable = new String[treeList.length() + 1];
    createTree();
    makeKey(treeList.removeTree(), "");

    String newStr = translate(inputStr);

    for(int i = 0; i < signTable.length; i++)
      System.out.println( signTable[i] + " : " + keyTable[i]);
    System.out.println("The Orginal string is " + (inputStr.length() * 16) + " bits long.");
    System.out.println("The new string is " + newStr.length() + " bits long.");

    System.out.println("The coded string looks like this: " + newStr);
  }

  public void createTree()
  {
    while(treeList.length() > 1)
      treeList.mergeTree();
  }

  public void makeKey(HuffmanTree tree, String codeStr)
  {

System.out.println("" + tree.getSign());

     if(tree.getLeftChild() == null)
     {
       signTable[posInTable] = tree.getSign();
       keyTable[posInTable] = codeStr;
       posInTable++;
     }
     else
     {
       makeKey(tree.getLeftChild(), codeStr + "0");
       makeKey(tree.getRightChild(), codeStr + "1");
     }
  }

  public String translate(String orginal)
  {
    String newStr = "";

    for(int i = 0; i < orginal.length(); i++)
      for(int j = 0; j < signTable.length; j++)
        if(orginal.charAt(i) == signTable[j])
          newStr += keyTable[j];

    return newStr;
  }
}