class TreeList
{
  private int count = 0;
  private LinkedElement first;

  public TreeList()
  {

  }

  public void addSign(char sign)
  {
    HuffmanTree Htemp = new HuffmanTree(sign);
    LinkedElement Etemp = new LinkedElement(Htemp);

    if( first == null )
      first = Etemp;
    else
    {
      Etemp.next = first;
      first = Etemp;
    }
    count++;
  }

  public void sortTree()
  {
    TreeList otherList = new TreeList();
    HuffmanTree aTemp;

    while( this.first != null )
    {
      aTemp = this.removeTree();
      otherList.insertTree( aTemp );
    }
    this.first = otherList.first;
  }

  public void mergeTree()
  {
    if( first != null )
      if( first.next != null )
      {
        HuffmanTree aTemp = removeTree();
        HuffmanTree bTemp = removeTree();

        HuffmanTree sumTemp = new HuffmanTree();
        sumTemp.setLeftChild( aTemp );
        sumTemp.setRightChild( bTemp );
        sumTemp.setFreq( aTemp.getFreq() + bTemp.getFreq() );

        insertTree( sumTemp );
      }
  }

  public HuffmanTree removeTree()
  {
    if( first != null )
    {
      HuffmanTree Htemp;
      Htemp = first.data;
      first = first.next;
      count--;
      return Htemp;
    }
    return null;
  }

  public void insertTree( HuffmanTree Htemp )
  {
    LinkedElement Etemp = new LinkedElement( Htemp );
    if( first == null )
      first = Etemp;
    else
    {
      LinkedElement p = first;
      while( p.next != null )
      {
        if( p.data.getFreq() <= Htemp.getFreq() && p.next.data.getFreq() >= Htemp.getFreq() )
          break;
          p = p.next;
      }
      Etemp.next = p.next;
      p.next = Etemp;
    }
    count++;
  }

  public int length()
  {
    return count;
  }

}